import { 
    trigger,
    state,
    style,
    transition,
    animate,
    keyframes
 } from '@angular/animations';

export const animations = [
    trigger('slideFromTop', [
        state('*', style({
            opacity: '1',
            transform: 'none'
            
        })),
        state('void', style({
            opacity: '0',
            transform: 'translateY(-100px)'
            
        })),
        transition('void => 200', animate('200ms ease-in-out')),
        transition('void => 400', animate('400ms ease-in-out')),
        transition('void => 500', animate('500ms ease-in-out')),
        transition('void => 600', animate('600ms ease-in-out')),
        transition('void => 700', animate('700ms ease-in-out')),
        transition('void => 800', animate('800ms ease-in-out')),
        transition('void => 900', animate('900ms ease-in-out')),
        transition('void => *', animate('300ms ease-in-out')),
        transition('* => void', animate('300ms ease-in-out')),
    ]),
    trigger('slideFromBottom', [
        state('*', style({
            opacity: '1',
            transform: 'none'
            
        })),
        state('void', style({
            opacity: '0',
            transform: 'translateY(100px)'
            
        })),
        transition('void => 200', animate('200ms ease-in-out')),
        transition('void => 400', animate('400ms ease-in-out')),
        transition('void => 500', animate('500ms ease-in-out')),
        transition('void => 600', animate('600ms ease-in-out')),
        transition('void => 700', animate('700ms ease-in-out')),
        transition('void => 800', animate('800ms ease-in-out')),
        transition('void => 900', animate('900ms ease-in-out')),
        transition('void => *', animate('300ms ease-in-out')),
        transition('* => void', animate('300ms ease-in-out')),

    ]),
    trigger('slideFromLeft', [
        state('*', style({
            opacity: '1',
            transform: 'none'
            
        })),
        state('void', style({
            opacity: '0',
            transform: 'translateX(-100px)'
            
        })),
        transition('void => 200', animate('200ms ease-in-out')),
        transition('void => 400', animate('400ms ease-in-out')),
        transition('void => 500', animate('500ms ease-in-out')),
        transition('void => 600', animate('600ms ease-in-out')),
        transition('void => 700', animate('700ms ease-in-out')),
        transition('void => 800', animate('800ms ease-in-out')),
        transition('void => 900', animate('900ms ease-in-out')),
        transition('void => *', animate('300ms ease-in-out')),
        transition('* => void', animate('300ms ease-in-out')),

    ]),

    trigger('slideFromRight', [
        state('*', style({
            opacity: '1',
            transform: 'none'
            
        })),
        state('void', style({
            opacity: '0',
            transform: 'translateX(100px)'
            
        })),
        transition('void => 200', animate('200ms ease-in-out')),
        transition('void => 400', animate('400ms ease-in-out')),
        transition('void => 500', animate('500ms ease-in-out')),
        transition('void => 600', animate('600ms ease-in-out')),
        transition('void => 700', animate('700ms ease-in-out')),
        transition('void => 800', animate('800ms ease-in-out')),
        transition('void => 900', animate('900ms ease-in-out')),
        transition('void => *', animate('300ms ease-in-out')),
        transition('* => void', animate('300ms ease-in-out')),

    ]),

    trigger('fadeIn', [
        state('*', style({
            opacity: '1',
        })),
        state('void', style({
            opacity: '0',
            
        })),
        transition('void => 200', animate('200ms ease-in-out')),
        transition('void => 400', animate('400ms ease-in-out')),
        transition('void => 500', animate('500ms ease-in-out')),
        transition('void => 600', animate('600ms ease-in-out')),
        transition('void => 700', animate('700ms ease-in-out')),
        transition('void => 800', animate('800ms ease-in-out')),
        transition('void => 900', animate('900ms ease-in-out')),
        transition('void => *', animate('300ms ease-in-out')),
        transition('* => void', animate('300ms ease-in-out')),

    ]),

    trigger('fadeOutOnly', [
        state('*', style({
            opacity: '1',
        })),
        state('void', style({
            opacity: '0',
            
        })),
        transition('100 => void', animate('100ms')),
        transition('200 => void', animate('200ms')),
        transition('400 => void', animate('400ms')),
        transition('500 => void', animate('500ms')),
        transition('600 => void', animate('600ms')),
        transition('700 => void', animate('700ms')),
        transition('800 => void', animate('800ms')),
        transition('900 => void', animate('900ms')),
        transition('* => void', animate('300ms ease-in-out')),

    ]),

    trigger('slideDown', [
        state('*', style({
            height: '*',
        })),
        state('void', style({
            height: '0',
            overflow: 'hidden'
        })),
        transition('void => 200', animate('200ms')),
        transition('void => 400', animate('400ms')),
        transition('void => 500', animate('500ms')),
        transition('void => 600', animate('600ms')),
        transition('void => 700', animate('700ms')),
        transition('void => 800', animate('800ms')),
        transition('void => 900', animate('900ms')),
        transition('void => *', animate('300ms')),
        transition('* => void', animate('300ms')),

    ])


]