import { Component, Input, OnInit } from '@angular/core';
import { environment } from 'environments/environment';
import { GlobalService, UserAccountService } from 'flow-concept-shared/services';

@Component({
  selector: 'app-change-login',
  templateUrl: './change-login.component.html',
  styleUrls: ['./change-login.component.css']
})
export class ChangeLoginComponent implements OnInit {

  @Input()
  public context: any = {};
  public otpContext: any = {};
  errorMessage: any;

  constructor(
    public userService: UserAccountService,
    public globalService: GlobalService
  ) { }

  ngOnInit() {
    this.context.clientName = environment.client_id;
  }

  submitChange() {
    this.errorMessage = null
    this.userService.requestLoginNameChange(this.context).subscribe(res => {
      if (res.result.status == 'error') {
        this.errorMessage = res.result.errorMessage;
        this.globalService.onError.emit();
        return;
      }
      this.otpContext = res.result;
    });

  }

}
