import { Component, ViewEncapsulation } from '@angular/core';
import { FlowCookieService } from '../../services/cookie/cookie.service';
import { GlobalService } from 'flow-concept-shared/services';



@Component({
  selector: 'cookie-bar',
  templateUrl: './cookie-bar.component.html',
  styleUrls: ['./cookie-bar.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class CookieBarComponent {

  public get isPrerender() {
    return window.navigator.userAgent.includes('prerender');
  }


  constructor(
    public cookieService: FlowCookieService,
    public gs: GlobalService,
  ) { }


  ngOnInit() {

  }

  acceptCookies(){
    this.cookieService.gdprConsent = '1';

  }

  rejectCookies(){
    this.cookieService.gdprConsent = '0';
  }

}
