import { Component, OnInit, Input } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
declare var window: any;
@Component({
  selector: 'app-multistep-wizard',
  templateUrl: './multistep-wizard.component.html',
  styleUrls: ['./multistep-wizard.component.css', './gsi-step-indicator.scss', './mixin_main.scss']
})
export class MultistepWizardComponent implements OnInit {

  private _steps: MultistepWizardComponentStep[] = [];
  private _id: any

  public get steps() {
    this._steps.sort((a,b) => {
      if (a.id>b.id)
        return 1;
      return -1;
    })
    return this._steps;
  }

  @Input()
  public set steps(value) {
    this._steps = value;
  }

  public get id() {
    return this.route.snapshot.queryParams['id'];
  }

  public get currentStep() {
    let result = this.steps.filter(s => {
      return s.urlRoute.endsWith(this.route.snapshot.url.toString());
    });
    return result[0];
  }

  constructor(public router: Router, public route: ActivatedRoute) { }

  ngOnInit() {
  }

}

export class MultistepWizardComponentStep {
  public id: number;
  public titleTranslation: string;
  public urlRoute: string;
}
