import { Component, OnInit } from '@angular/core';
import { SignalrNotificationService, TranslationSharedService } from '../../services';

@Component({
  selector: 'app-notification-list',
  templateUrl: './notification-list.component.html',
  styleUrls: ['./notification-list.component.css']
})
export class NotificationListComponent implements OnInit {
  public pageNo:number = 1;
  
  public loading: boolean = false;

  constructor(public signalRService: SignalrNotificationService, public translationService: TranslationSharedService) { }

  ngOnInit() {
    this.signalRService.getNotifications().subscribe(res => {
    this.signalRService.messages.filter(m=>m.isUnread).forEach(item => {
      item.isUnread = false; 
      item.wasNew = true;
    });
    this.signalRService.setReadReceipt();

  });
  }

  ngOnDestroy() {
    this.signalRService.messages.forEach(item => {
      item.wasNew = false;
    });
  }
  
  public get messages(): any[] {
    return this.signalRService.messages.slice().sort((a,b) => (a.creationTime.toString() < b.creationTime.toString() ? 1 : -1));
  }

  openNextPage() {
    this.loading = true;
    this.signalRService.messagePageNo++;
    this.signalRService.getNotifications().subscribe(res => this.loading = false);
  }

  notificationClick(message) {
    this.signalRService.onNotificationClick.emit(message);
  }

}
