import { Component, OnInit, Output, EventEmitter, Renderer2, Input } from '@angular/core';

@Component({
  selector: 'flow-qr-scanner',
  templateUrl: './qr-scanner.component.html',
  styleUrls: ['./qr-scanner.component.css']
})
export class QrScannerComponent implements OnInit {

  private value: string = '';

  @Input()
  public disabled: boolean;
  private eventListener: any;
  @Output()
  public valueRead: EventEmitter<any> = new EventEmitter();
  public timeout: any;

  constructor(private renderer: Renderer2) { }

  ngOnInit() {

    this.eventListener = this.renderer.listen(document, 'keydown', (event) => {
      if (this.disabled)
        return;
      if (this.timeout)
        clearTimeout(this.timeout);
      if (event.keyCode != 13) {
        if (event.keyCode >= 31) {
          this.value += event.key.toString().toUpperCase();
          this.timeout = setTimeout(() => {
            this.value = '';
          }, 1000);
        }
      }
      else {
        this.valueRead.emit(this.value);
        this.value = '';
      }
    });
  }

  ngOnDestroy() {
    this.eventListener();
  }

}
