import { Directive, ElementRef, Input, Output, EventEmitter } from '@angular/core';
import { GlobalService } from 'flow-concept-shared/services';
declare var $: any;
declare var jQuery: any;
declare var moment: any;

@Directive({
  selector: '[datetimepicker]'
})
export class DatetimepickerDirective {

  @Input('options') options: any = {};
  @Input('datetimepicker') type: string = 'datetime';
  @Input('format') format: string = 'DD.MM.YYYY HH:mm'
  private dateSelected: any;
  @Input('selectedTime') public set selectedTime(value)
  {
    if(value && value!='') {
        $(this.elRef.nativeElement).val(moment(value).format(this.format));
    }
    else{
      $(this.elRef.nativeElement).val('');
    }
  }

  @Output('dateSelected') onDateSelected: EventEmitter<any> = new EventEmitter<any>();

  @Input('ignoreTimeZone') ignoreTimeZone = false;

  constructor(private elRef: ElementRef, public globalService: GlobalService) { }

  ngOnInit() {
    if (!$(this.elRef.nativeElement).datetimepicker)
      console.log('JQuery Datetimepicker not found');

      switch(this.type){
        case 'datetime':
          this.options.datepicker = true;
          this.options.timepicker = true;
          break;
        case 'date':
          this.options.datepicker = true;
          this.options.timepicker = false;
          break;
        case 'time':
          this.options.datepicker = false;
          this.options.timepicker = true;
          break;
      }
      jQuery.datetimepicker.setLocale(this.globalService._currentLanguage);
      $.datetimepicker.setDateFormatter('moment');
      this.options.format = this.format;
      this.options.onChangeDateTime = (date, input) => {
        //input.blur();
        if (!date) {
          this.onDateSelected.emit(null);
          return;
        }

        if (this.type=='date')
          date.setHours(0,0,0,0);


        //if (!this.dateSelected || this.dateSelected.toISOString() != date.toISOString()) {
         // this.dateSelected = date;
          if (this.ignoreTimeZone)
            this.onDateSelected.emit(moment(date).format('YYYY-MM-DD[T]HH:mm'));
          else
            this.onDateSelected.emit(date.toISOString());
        //}
      };
      this.elRef.nativeElement.autoComplete='false';
    $(this.elRef.nativeElement).datetimepicker(this.options);
  }
}
