import { Injectable } from '@angular/core';
import { FlowHttpClient } from '../httpClient/httpClient';
import { ApplicationConfig } from '../../applicationConfig';
import { Observable, of } from 'rxjs';
import { environment } from 'environments/environment';

@Injectable({
    providedIn: 'root'
  })
export class ApplicationSharedService {

    constructor(public http: FlowHttpClient) { }

    private endpointObs: Observable<any>;
    public allowedApplications: any = [];
    public _currentApplication: any = {};
    public get endpoints(): any[] {
        return environment.endpoints;
    }


    public get currentApplication() {
        return this._currentApplication;
    }

    public set currentApplication(value) {
        this._currentApplication = value;
    }


    public getAdminClients() {
        return this.http.get(this.endpoints['IdentityServer'], `/clients/getadminclients`);
    }

    // public checkVersion(){
    //     return this.http.get(this.endpoints['IdentityServer'], 'versions.txt');
    // }

    //TODO: Add get from https://id.flowconcept.io/versions.txt
    
}