import { Injectable, Input } from '@angular/core';
import { CanActivate, Router, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { UserAccountService } from '../user-account/user-account.service';
import { ApplicationSharedService } from '../application-shared/application-shared.service';
import { TranslationSharedService } from '../translation-shared/translation-shared.service';
import { FlowHttpClient } from '../httpClient/httpClient';
import { ApplicationConfig } from '../../applicationConfig';
declare var window;
import * as moment from 'moment';
import { map } from 'rxjs/operators';
import { environment } from 'environments/environment';
import { from } from 'rxjs';
// import packageInfo from '../../../../package.json';
// import { compareVersions } from 'compare-versions';


@Injectable({
  providedIn: 'root'
})
export class AppSettingsLoaderService implements CanActivate {

  public application_id: string;
  public requiredVersion: any;
  public latestVersion: any;
  public versionCheck: string;
  compareRequired: any;
  compareLatest: any;
  @Input()
  public updateRequired: boolean = false;
  @Input()
  public updateAvailable: boolean = false;


  constructor(public userService: UserAccountService, public applicationService: ApplicationSharedService, public http: FlowHttpClient, public translationService: TranslationSharedService) {
  }
  canActivate(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ) {
    return from(this.loadSettings()).pipe(map(res => true));
  }
  async loadSettings() {
    //TODO: add version checker logic
    // let r = await this.applicationService.checkVersion().toPromise();
    // console.log(r)
    //   this.requiredVersion = r.platforms.web.requiredVersion;
    //   this.latestVersion = r.platforms.web.latestVersion;

    //   this.compareRequired = compareVersions(this.requiredVersion, packageInfo.version);
    //   this.compareLatest = compareVersions(this.latestVersion, packageInfo.version);

    //   if (this.compareRequired = 1){
    //     return this.updateRequired;
    //   }

    //   if(this.compareLatest = 1){
    //     // this.versionCheck = 'update_available';
    //     return this.updateAvailable;
    //   }

    //   else if(this.compareLatest = 0){
    //     return '';
    //   }




    await this.userService.getCurrentUserv2().toPromise();
    await this.translationService.getTranslations().toPromise();
    await this.translationService.getCountries().toPromise();
    await this.translationService.getLanguages(environment.application_id).toPromise();
    moment.locale(this.translationService.currentLanguage);


  }

  async loadSettingsv2() {
    //TODO: add version checker logic
    // let r = await this.applicationService.checkVersion().toPromise();
    // console.log(r)
    //   this.requiredVersion = r.platforms.web.requiredVersion;
    //   this.latestVersion = r.platforms.web.latestVersion;

    //   this.compareRequired = compareVersions(this.requiredVersion, packageInfo.version);
    //   this.compareLatest = compareVersions(this.latestVersion, packageInfo.version);

    //   if (this.compareRequired = 1){
    //     return this.updateRequired;
    //   }

    //   if(this.compareLatest = 1){
    //     // this.versionCheck = 'update_available';
    //     return this.updateAvailable;
    //   }

    //   else if(this.compareLatest = 0){
    //     return '';
    //   }




    await this.userService.getCurrentUserv2().toPromise();
    await this.translationService.getTranslations().toPromise();
    await this.translationService.getCountries().toPromise();
    await this.translationService.getLanguages(environment.application_id).toPromise();
    moment.locale(this.translationService.currentLanguage);


  }

}

