import { Injectable } from '@angular/core';
import { CanActivate, Router, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { UserAccountService } from '../user-account/user-account.service';
import { ApplicationSharedService } from '../application-shared/application-shared.service'
import { FlowHttpClient } from '../httpClient/httpClient';
import { Observable } from "rxjs/Rx";
import { map } from 'rxjs/operators';
declare var window;

@Injectable({
  providedIn: 'root'
})
export class ClaimsGuardService implements CanActivate {

  constructor(public userAccountService: UserAccountService, public router: Router, public applicationService: ApplicationSharedService, public http: FlowHttpClient) {
   }

   canActivate(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
    ) {
      return this.userAccountService.checkCurentUserClaimsv2(route).pipe(map(res => {
        if (!res)
          this.userAccountService.onAccessRefused.emit(state.url);
        return res;
      }));
  }
}
