import { Injectable } from '@angular/core';
import { GlobalService } from 'flow-concept-shared/services/global/global.service';
import { UUID } from "angular2-uuid";


@Injectable({
  providedIn: 'root'
})
export class FlowCookieService {
  instanceId: any;
  
  private _gdprConsent: string;

  public get gdprConsent(){
    if (!this._gdprConsent) this._gdprConsent = this.get('GdprConsent');
    return this._gdprConsent;
  }

  public set gdprConsent(value) {
    this._gdprConsent = value;
    this.put('GdprConsent', value, null);
  }


  constructor(public globalService: GlobalService) { 
  }

  get(name) {
    if(!localStorage.getItem(name))
      return null;
    
    var obj = null;
    try{
      obj = JSON.parse(localStorage.getItem(name), this.globalService.reviver);
    } catch { this.put(name, localStorage.getItem(name)); return localStorage.getItem(name) }

    if (obj.expires && Date.parse(obj.expires) < Date.parse(new Date().toISOString())) {
      localStorage.removeItem(name);
      return null;
    }
    else 
      return obj.value;
  }

  

  remove(name) {
    localStorage.removeItem(name);
  }

  put(name, value, exp = null) {
    localStorage[name] = JSON.stringify({ value: value, expires: exp ? exp.toISOString() : null }, this.globalService.replacer);
  }
}
