import { Injectable } from '@angular/core';
import { TranslationSharedService } from '../translation-shared/translation-shared.service';
import { TranslationPipe } from '../../pipes';
import { Modal, BSModalContext } from 'ngx-modialog-7/plugins/bootstrap';
import { overlayConfigFactory } from 'ngx-modialog-7';



@Injectable({
    providedIn: 'root'
  })
export class ModalService {

constructor(public translationService: TranslationSharedService, public modal: Modal) { }

openConfirm(trans) {
        return this.modal.confirm()
        .title(new TranslationPipe().transform(`${trans}.title`, this.translationService.translations))
        .body(new TranslationPipe().transform(`${trans}.body`, this.translationService.translations))
        .okBtn(new TranslationPipe().transform(`ok`, this.translationService.translations))
        .cancelBtn(new TranslationPipe().transform(`cancel`, this.translationService.translations))
        .open();
}

openAlert(trans) {
    return this.modal.alert()
    .title(new TranslationPipe().transform(`${trans}.title`, this.translationService.translations))
    .body(new TranslationPipe().transform(`${trans}.body`, this.translationService.translations))
    .okBtn(new TranslationPipe().transform(`ok`, this.translationService.translations))
    .open();
}

openRawAlert(titleText, bodyText) {
    return this.modal.alert()
    .title(titleText)
    .body(bodyText)
    .okBtn(new TranslationPipe().transform(`ok`, this.translationService.translations))
    .open();
}


openComponent(type, model) {
    return this.modal.open(type, overlayConfigFactory(model, BSModalContext));
}
}