import { Injectable, EventEmitter } from '@angular/core';
import { NavigationStart, Router } from '@angular/router';

@Injectable({
    providedIn: 'root'
  })
export class SidebarService {

    public onSidebarOpen = new EventEmitter(true);
    public onSidebarClose = new EventEmitter(true);
    private offset: number;
    private sidebarOpen = false;
constructor(public router: Router) {
    this.router.events.subscribe(event => {
        if (event instanceof NavigationStart) {
            this.closeSidebar();
        }
    });
 }

openSidebar(component, data:any = null, width = '400px') {
    
    this.sidebarOpen = true;
    // this.offset = $(document).scrollTop();
    // $(document).scrollTop(0);
    $('body').addClass('modal--opened');
    this.onSidebarOpen.emit({type: 'regular', component: component, data: data, width: width});
}

openIframeSidebar(url, width = '400px') {
    this.sidebarOpen = true;
    // this.offset = $(document).scrollTop();
    // $(document).scrollTop(0);
    $('body').addClass('modal--opened');
    this.onSidebarOpen.emit({type: 'iframe', url: url, width: width});
}

closeSidebar(evt = null) {
    $('body').removeClass('modal--opened');
    // $(document).scrollTop(this.offset);
    // this.offset = 0;
    if (this.sidebarOpen)
        this.onSidebarClose.emit(evt);
    this.sidebarOpen = false;
}

}